(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.submitAjaxFormButton = mod.exports;
  }
})(this, function (exports) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = submitAjaxFormButton;
  var submitAjaxFormButtonRequest = function submitAjaxFormButtonRequest(url, method) {
    return {
      type: '_RFORM_SUBMIT_AJAX_FORM_BUTTON_REQUEST',
      url: url,
      method: method
    };
  };

  var submitAjaxFormButtonReturn = function submitAjaxFormButtonReturn(url, method) {
    return {
      type: '_RFORM_SUBMIT_AJAX_FORM_BUTTON_RETURN',
      url: url,
      method: method
    };
  };

  function submitAjaxFormButton(adapter, url, method, afterSuccess, afterError) {
    return function (dispatch) {
      dispatch(submitAjaxFormButtonRequest(url, method));

      return fetch(url, adapter.requestHash).then(function (response) {
        var status = response.status;
        var statusText = response.statusText;

        dispatch(submitAjaxFormButtonReturn(url, method));
        if (status >= 400) {
          console.error('Submit Ajax Form Button Error ' + status + ': ' + statusText);
          afterError && afterError(response);
        } else {
          afterSuccess && afterSuccess(response);
        }
      });
    };
  }
});