(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'lodash/merge', './Base'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('lodash/merge'), require('./Base'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.merge, global.Base);
    global.JsonApi = mod.exports;
  }
})(this, function (exports, _merge, _Base) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _merge2 = _interopRequireDefault(_merge);

  var _Base2 = _interopRequireDefault(_Base);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var JsonApiAdapter = function (_BaseAdapter) {
    _inherits(JsonApiAdapter, _BaseAdapter);

    function JsonApiAdapter() {
      _classCallCheck(this, JsonApiAdapter);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(JsonApiAdapter).apply(this, arguments));
    }

    _createClass(JsonApiAdapter, [{
      key: 'handleAjaxResponse',
      value: function handleAjaxResponse(json) {
        var changes = {};

        if (json.data) {
          changes[json.data.type] = {};
          changes[json.data.type][json.data.id] = (0, _merge2.default)(json.data.attributes, { id: json.data.id });
        }

        return [changes, json.errors];
      }
    }, {
      key: '_addModelPropsToJson',
      value: function _addModelPropsToJson(json) {
        var model = this.model;
        var attrs = this.attrs;
        var properties = this.properties;
        var id = this.id;


        json.data.type = model + 's'; // TODO: Not the best pluralization...
        if (id) json.data.id = String(id);

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = properties[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var property = _step.value;

            json.data.attributes[property] = attrs[property];
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
    }, {
      key: 'requestHash',
      get: function get() {
        var data = this._json;

        return {
          method: this.form._method.value,
          body: JSON.stringify(data),
          credentials: 'same-origin',
          headers: {
            'Content-Type': 'application/vnd.api+json',
            Accept: 'application/vnd.api+json',
            'X-CSRF-TOKEN': this.form.authenticity_token.value
          }
        };
      }
    }, {
      key: '_json',
      get: function get() {
        var jsonObject = { data: { attributes: {} } };
        this._addModelPropsToJson(jsonObject);
        // this._addSubmodelPropsToJson(jsonObject)
        return jsonObject;
      }
    }]);

    return JsonApiAdapter;
  }(_Base2.default);

  exports.default = JsonApiAdapter;
});