(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react);
    global.Form = mod.exports;
  }
})(this, function (exports, _react) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var Form = function (_Component) {
    _inherits(Form, _Component);

    function Form() {
      _classCallCheck(this, Form);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(Form).apply(this, arguments));
    }

    _createClass(Form, [{
      key: 'getChildContext',
      value: function getChildContext() {
        return {
          // formObject: this.props.formObject,
          formObjectClass: this.props.formObjectClass,
          model: this.props.model,
          // serverErrors: this.props.errors,
          formId: this.props.formId,
          form: this._form,
          onSubmit: this.props.onSubmit,
          preventEnterSubmit: this.props.preventEnterSubmit
        };
      }
    }, {
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.props.ensureStateObjectExistence();
        if (this.props.immediateSubmit) this.props.onSubmit({ target: this._form });
      }
    }, {
      key: 'componentDidUpdate',
      value: function componentDidUpdate(prevProps, prevState) {
        if (this.props.formId != prevProps.formId) {
          this.props.ensureStateObjectExistence();
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _props = this.props;
        var onSubmit = _props.onSubmit;
        var children = _props.children;
        var multipart = _props.multipart;
        var className = _props.className;
        var commit = _props.commit;
        var formId = _props.formId;
        var action = _props.action;
        var authToken = _props.authToken;
        var method = _props.method;
        var enctype = _props.enctype;
        var combinedClassName = _props.combinedClassName;
        var formMethod = _props.formMethod;
        var hiddenMethod = _props.hiddenMethod;


        return _react2.default.createElement(
          'form',
          {
            className: combinedClassName, action: action, method: formMethod,
            onSubmit: onSubmit, encType: enctype, id: formId,
            ref: function ref(element) {
              return _this2._form = element;
            }
          },
          _react2.default.createElement('input', { type: 'hidden', name: 'utf8', value: '✓' }),
          this.optionalHiddenField('authenticity_token', authToken),
          this.optionalHiddenField('commit', commit),
          _react2.default.createElement('input', { type: 'hidden', name: '_method', value: hiddenMethod }),
          children
        );
      }
    }, {
      key: 'optionalHiddenField',
      value: function optionalHiddenField(name, hiddenValue) {
        if (hiddenValue) {
          return _react2.default.createElement('input', { type: 'hidden', name: name, value: hiddenValue });
        }
      }
    }]);

    return Form;
  }(_react.Component);

  Form.childContextTypes = {
    // formObject: PropTypes.object,
    formObjectClass: _react.PropTypes.func,
    model: _react.PropTypes.string,
    // serverErrors: PropTypes.array,
    formId: _react.PropTypes.string,
    form: _react.PropTypes.object,
    onSubmit: _react.PropTypes.func,
    preventEnterSubmit: _react.PropTypes.bool
  };
  exports.default = Form;
});