(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react);
    global.FormButton = mod.exports;
  }
})(this, function (exports, _react) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var FormButton = function (_Component) {
    _inherits(FormButton, _Component);

    function FormButton() {
      _classCallCheck(this, FormButton);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(FormButton).apply(this, arguments));
    }

    _createClass(FormButton, [{
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _props = this.props;
        var action = _props.action;
        var method = _props.method;
        var authToken = _props.authToken;
        var children = _props.children;
        var onSubmit = _props.onSubmit;
        var combinedClassName = _props.combinedClassName;


        return _react2.default.createElement(
          'form',
          { action: action, method: 'POST', ref: function ref(_ref) {
              return _this2._form = _ref;
            } },
          _react2.default.createElement('input', { type: 'hidden', name: 'authenticity_token', value: authToken }),
          _react2.default.createElement('input', { type: 'hidden', name: '_method', value: method }),
          _react2.default.createElement(
            'button',
            {
              className: combinedClassName, type: 'submit',
              onClick: function onClick(event) {
                return onSubmit(event, _this2._form);
              }
            },
            children
          )
        );
      }
    }]);

    return FormButton;
  }(_react.Component);

  FormButton.propTypes = {
    action: _react.PropTypes.string.isRequired,
    method: _react.PropTypes.string.isRequired,
    authToken: _react.PropTypes.string.isRequired,
    onSubmit: _react.PropTypes.func.isRequired,
    className: _react.PropTypes.string
  };
  exports.default = FormButton;
});