(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', './inputs/Default', './inputs/FileField', './inputs/Textarea', '../containers/inputs/Select', '../containers/inputs/Checkbox'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('./inputs/Default'), require('./inputs/FileField'), require('./inputs/Textarea'), require('../containers/inputs/Select'), require('../containers/inputs/Checkbox'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.Default, global.FileField, global.Textarea, global.Select, global.Checkbox);
    global.Input = mod.exports;
  }
})(this, function (exports, _react, _Default, _FileField, _Textarea, _Select, _Checkbox) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _Default2 = _interopRequireDefault(_Default);

  var _FileField2 = _interopRequireDefault(_FileField);

  var _Textarea2 = _interopRequireDefault(_Textarea);

  var _Select2 = _interopRequireDefault(_Select);

  var _Checkbox2 = _interopRequireDefault(_Checkbox);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var Input = function (_Component) {
    _inherits(Input, _Component);

    function Input() {
      _classCallCheck(this, Input);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(Input).apply(this, arguments));
    }

    _createClass(Input, [{
      key: 'render',
      value: function render() {
        var type = this.props.type;


        switch (type) {
          case 'textarea':
            return _react2.default.createElement(_Textarea2.default, this.props);

          case 'file':
            return _react2.default.createElement(_FileField2.default, this.props);

          case 'checkbox':
            return _react2.default.createElement(_Checkbox2.default, this.props);

          case 'select':
          case 'dropdown':
            return _react2.default.createElement(_Select2.default, this.props);

          default:
            return _react2.default.createElement(_Default2.default, this.props);
        }
      }
    }]);

    return Input;
  }(_react.Component);

  Input.propTypes = {
    model: _react.PropTypes.string.isRequired,
    name: _react.PropTypes.string.isRequired,
    formId: _react.PropTypes.string.isRequired,
    // formObject: PropTypes.object.isRequired,
    value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number, _react.PropTypes.bool]).isRequired,
    placeholder: _react.PropTypes.string,
    ariaLabel: _react.PropTypes.string,
    labelText: _react.PropTypes.string.isRequired
  };
  exports.default = Input;
});