(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', '../wrappers/Label', '../wrappers/Errors', '../wrappers/Input'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('../wrappers/Label'), require('../wrappers/Errors'), require('../wrappers/Input'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.Label, global.Errors, global.Input);
    global.InputSet = mod.exports;
  }
})(this, function (exports, _react, _Label, _Errors, _Input) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _Label2 = _interopRequireDefault(_Label);

  var _Errors2 = _interopRequireDefault(_Errors);

  var _Input2 = _interopRequireDefault(_Input);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var InputSet = function (_Component) {
    _inherits(InputSet, _Component);

    function InputSet() {
      _classCallCheck(this, InputSet);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(InputSet).apply(this, arguments));
    }

    _createClass(InputSet, [{
      key: 'render',
      value: function render() {
        var _props = this.props;
        var errors = _props.errors;
        var combinedWrapperClassName = _props.combinedWrapperClassName;
        var labelAfterInput = _props.labelAfterInput;
        var labelText = _props.labelText;
        var formId = _props.formId;
        var ariaLabelOnly = _props.ariaLabelOnly;
        var attribute = _props.attribute;
        var labelClassName = _props.labelClassName;
        var errorClassName = _props.errorClassName;
        var model = _props.model;
        var children = _props.children;


        if (ariaLabelOnly) {
          return _react2.default.createElement(
            'div',
            { className: combinedWrapperClassName },
            _react2.default.createElement(_Input2.default, _extends({}, this.props, { ariaLabel: labelText })),
            _react2.default.createElement(_Errors2.default, {
              className: errorClassName, attribute: attribute, errors: errors,
              formId: formId
            }),
            children
          );
        } else if (labelAfterInput) {
          return _react2.default.createElement(
            'div',
            { className: combinedWrapperClassName },
            _react2.default.createElement(_Input2.default, this.props),
            _react2.default.createElement(_Label2.default, {
              className: labelClassName, attribute: attribute,
              model: model, content: labelText, formId: formId
            }),
            _react2.default.createElement(_Errors2.default, {
              className: errorClassName, attribute: attribute, errors: errors,
              formId: formId
            }),
            children
          );
        } else {
          return _react2.default.createElement(
            'div',
            { className: combinedWrapperClassName },
            _react2.default.createElement(_Label2.default, {
              className: labelClassName, attribute: attribute,
              model: model, content: labelText, formId: formId
            }),
            _react2.default.createElement(_Input2.default, this.props),
            _react2.default.createElement(_Errors2.default, {
              className: errorClassName, attribute: attribute, errors: errors,
              formId: formId
            }),
            children
          );
        }
      }
    }]);

    return InputSet;
  }(_react.Component);

  InputSet.propTypes = {
    model: _react.PropTypes.string.isRequired,
    attribute: _react.PropTypes.string.isRequired,
    // type: PropTypes.string,
    // value: PropTypes.oneOfType([
    //   PropTypes.string,
    //   PropTypes.arrayOf(PropTypes.number),
    // ]).isRequired,
    // noLabel: PropTypes.bool,
    // inlineLabel: PropTypes.bool,
    // submodel: PropTypes.string,

    formId: _react.PropTypes.string.isRequired,
    errors: _react.PropTypes.array,
    className: _react.PropTypes.string,
    combinedWrapperClassName: _react.PropTypes.string.isRequired,
    labelText: _react.PropTypes.string.isRequired,
    ariaLabelOnly: _react.PropTypes.bool,
    labelAfterInput: _react.PropTypes.bool
  };
  exports.default = InputSet;
});