(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react);
    global.Checkbox = mod.exports;
  }
})(this, function (exports, _react) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var Checkbox = function (_Component) {
    _inherits(Checkbox, _Component);

    function Checkbox() {
      _classCallCheck(this, Checkbox);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(Checkbox).apply(this, arguments));
    }

    _createClass(Checkbox, [{
      key: 'componentDidUpdate',
      value: function componentDidUpdate() {
        if ([undefined, ''].includes(this.props.value)) this.props.saveInitialValue();
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props;
        var id = _props.id;
        var name = _props.name;
        var ariaLabel = _props.ariaLabel;
        var labelText = _props.labelText;
        var onChange = _props.onChange;
        var combinedClassName = _props.combinedClassName;
        var checkboxWrapperClassName = _props.checkboxWrapperClassName;
        var value = _props.value;
        var checkedValue = _props.checkedValue;
        var uncheckedValue = _props.uncheckedValue;
        var disabled = _props.disabled;


        return _react2.default.createElement(
          'span',
          { className: checkboxWrapperClassName },
          _react2.default.createElement('input', {
            type: 'hidden',
            name: name,
            value: uncheckedValue
          }),
          _react2.default.createElement('input', {
            id: id,
            type: 'checkbox',
            name: name,
            'aria-label': ariaLabel || labelText,
            className: combinedClassName,
            onChange: onChange,
            value: checkedValue,
            disabled: disabled,
            defaultChecked: value
          })
        );
      }
    }]);

    return Checkbox;
  }(_react.Component);

  exports.default = Checkbox;
});