(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react);
    global.Default = mod.exports;
  }
})(this, function (exports, _react) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var Default = function (_Component) {
    _inherits(Default, _Component);

    function Default() {
      _classCallCheck(this, Default);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(Default).apply(this, arguments));
    }

    _createClass(Default, [{
      key: 'render',
      value: function render() {
        var _props = this.props;
        var inputId = _props.inputId;
        var type = _props.type;
        var name = _props.name;
        var value = _props.value;
        var placeholder = _props.placeholder;
        var ariaLabel = _props.ariaLabel;
        var labelText = _props.labelText;
        var onChange = _props.onChange;
        var onBlur = _props.onBlur;
        var combinedClassName = _props.combinedClassName;
        var min = _props.min;
        var max = _props.max;
        var formId = _props.formId;
        var disabled = _props.disabled;
        var onKeyPress = _props.onKeyPress;


        return _react2.default.createElement('input', {
          id: inputId,
          form: formId,
          type: type || 'text',
          name: name,
          value: value,
          placeholder: placeholder,
          'aria-label': ariaLabel || labelText,
          className: combinedClassName,
          onChange: onChange,
          onBlur: onBlur,
          onKeyPress: onKeyPress,
          min: min,
          max: max,
          disabled: disabled
        });
      }
    }]);

    return Default;
  }(_react.Component);

  exports.default = Default;
});