(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react);
    global.Textarea = mod.exports;
  }
})(this, function (exports, _react) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var Textarea = function (_Component) {
    _inherits(Textarea, _Component);

    function Textarea() {
      _classCallCheck(this, Textarea);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(Textarea).apply(this, arguments));
    }

    _createClass(Textarea, [{
      key: 'render',
      value: function render() {
        var _props = this.props;
        var id = _props.id;
        var name = _props.name;
        var value = _props.value;
        var placeholder = _props.placeholder;
        var ariaLabel = _props.ariaLabel;
        var labelText = _props.labelText;
        var onChange = _props.onChange;
        var combinedClassName = _props.combinedClassName;
        var disabled = _props.disabled;


        return _react2.default.createElement('textarea', {
          id: id,
          name: name,
          value: value,
          placeholder: placeholder,
          'aria-label': ariaLabel || labelText,
          className: combinedClassName,
          onChange: onChange,
          disabled: disabled
        });
      }
    }]);

    return Textarea;
  }(_react.Component);

  exports.default = Textarea;
});