(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react-redux', 'lodash/values', 'lodash/assign', '../actions/updateAction', '../components/Button'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react-redux'), require('lodash/values'), require('lodash/assign'), require('../actions/updateAction'), require('../components/Button'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.reactRedux, global.values, global.assign, global.updateAction, global.Button);
    global.Button = mod.exports;
  }
})(this, function (exports, _reactRedux, _values, _assign, _updateAction, _Button) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _values2 = _interopRequireDefault(_values);

  var _assign2 = _interopRequireDefault(_assign);

  var _updateAction2 = _interopRequireDefault(_updateAction);

  var _Button2 = _interopRequireDefault(_Button);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _toConsumableArray(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
        arr2[i] = arr[i];
      }

      return arr2;
    } else {
      return Array.from(arr);
    }
  }

  var mapStateToProps = function mapStateToProps(state, ownProps) {
    var children = ownProps.children;
    var formId = ownProps.formId;
    var className = ownProps.className;
    var disableOnInvalid = ownProps.disableOnInvalid;
    var disableOnUnchanged = ownProps.disableOnUnchanged;
    var invalidDisabledLabel = ownProps.invalidDisabledLabel;
    var unchangedDisabledLabel = ownProps.unchangedDisabledLabel;

    var formState = state.rform[formId];

    var renderedLabel = ownProps.label || children;
    var disabled = disabled || false;

    if (formState) {
      if (!disabled && disableOnInvalid && allErrors(formState).length) {
        disabled = true;
        renderedLabel = invalidDisabledLabel || renderedLabel;
      }

      if (!disabled && disableOnUnchanged && !formState._changes.length) {
        disabled = true;
        renderedLabel = unchangedDisabledLabel || renderedLabel;
      }
    }

    return {
      renderedLabel: renderedLabel,
      disabled: disabled,
      combinedClassName: ['button', className].join(' ')
    };
  };

  var mapDispatchToProps = function mapDispatchToProps(dispatch, ownProps) {
    return {
      onClick: function onClick(_e) {
        var formId = ownProps.formId;
        dispatch((0, _updateAction2.default)(formId, 'commit', [], ownProps.commit));
        return true;
      }
    };
  };

  function allErrors(formAttributes) {
    if (!formAttributes || !formAttributes.errors) return [];
    return _assign2.default.apply(undefined, _toConsumableArray((0, _values2.default)(formAttributes.errors)));
  }

  exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_Button2.default);
});