(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react-redux', '../utils/getErrors', '../components/Errors'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react-redux'), require('../utils/getErrors'), require('../components/Errors'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.reactRedux, global.getErrors, global.Errors);
    global.Errors = mod.exports;
  }
})(this, function (exports, _reactRedux, _getErrors, _Errors) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _getErrors2 = _interopRequireDefault(_getErrors);

  var _Errors2 = _interopRequireDefault(_Errors);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var mapStateToProps = function mapStateToProps(state, ownProps) {
    var allErrors = ownProps.errors;
    if (!allErrors || !allErrors.length) {
      allErrors = (0, _getErrors2.default)(state.rform[ownProps.formId], ownProps.attribute, ownProps.submodelPath, ownProps.errors);
    }

    var combinedClassName = ['inline-errors', ownProps.className].join(' ');

    return {
      allErrors: allErrors,
      combinedClassName: combinedClassName
    };
  };

  var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return {};
  };

  exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_Errors2.default);
});