(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react-redux', '../actions/submitAjaxFormButton', '../components/FormButton'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react-redux'), require('../actions/submitAjaxFormButton'), require('../components/FormButton'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.reactRedux, global.submitAjaxFormButton, global.FormButton);
    global.FormButton = mod.exports;
  }
})(this, function (exports, _reactRedux, _submitAjaxFormButton, _FormButton) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _submitAjaxFormButton2 = _interopRequireDefault(_submitAjaxFormButton);

  var _FormButton2 = _interopRequireDefault(_FormButton);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var mapStateToProps = function mapStateToProps(state, ownProps) {
    var combinedClassName = ownProps.className || '';

    return {
      combinedClassName: combinedClassName,

      authToken: ownProps.authToken || state.authToken || state.settings && state.settings.authToken

    };
  };

  var mapDispatchToProps = function mapDispatchToProps(dispatch, ownProps) {
    var submit = function submit(form) {
      var ajax = ownProps.ajax;
      var action = ownProps.action;
      var method = ownProps.method;
      var afterSuccess = ownProps.afterSuccess;
      var afterError = ownProps.afterError;
      var adapter = ownProps.adapter;


      if (ajax) {
        dispatch((0, _submitAjaxFormButton2.default)(new adapter(form), action, method, afterSuccess, afterError));
      } else {
        form.submit();
      }
    };

    return {
      onSubmit: function onSubmit(event, form) {
        event.preventDefault();

        var confirmationMessage = ownProps.confirm;

        if (typeof confirmationMessage === 'string') {
          if (window.confirm(confirmationMessage)) submit(form);
        } else {
          submit(form);
        }
      }
    };
  };

  exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_FormButton2.default);
});