(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react-redux', '../utils/modelParams', '../utils/translations', '../components/Label'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react-redux'), require('../utils/modelParams'), require('../utils/translations'), require('../components/Label'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.reactRedux, global.modelParams, global.translations, global.Label);
    global.Label = mod.exports;
  }
})(this, function (exports, _reactRedux, _modelParams, _translations, _Label) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _Label2 = _interopRequireDefault(_Label);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _toConsumableArray(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
        arr2[i] = arr[i];
      }

      return arr2;
    } else {
      return Array.from(arr);
    }
  }

  var mapStateToProps = function mapStateToProps(state, ownProps) {
    return {
      htmlFor: ownProps.htmlFor || (0, _modelParams.getId)(ownProps.formId, ownProps.model, ownProps.attribute, ownProps.submodelPath),
      content: ownProps.content || ownProps.children || _translations.optionalTranslation.apply(undefined, ['rform', ownProps.model].concat(_toConsumableArray(ownProps.submodelPath || []), [ownProps.attribute, 'label'])) || ''
    };
  };

  var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return {};
  };

  exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_Label2.default);
});