(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react-redux', '../../actions/updateAction', '../../components/inputs/Checkbox'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react-redux'), require('../../actions/updateAction'), require('../../components/inputs/Checkbox'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.reactRedux, global.updateAction, global.Checkbox);
    global.Checkbox = mod.exports;
  }
})(this, function (exports, _reactRedux, _updateAction, _Checkbox) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _updateAction2 = _interopRequireDefault(_updateAction);

  var _Checkbox2 = _interopRequireDefault(_Checkbox);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var mapStateToProps = function mapStateToProps(state, ownProps) {
    var checkedValue = ownProps.checkedValue || '1';
    var uncheckedValue = ownProps.uncheckedValue || '0';

    var checkboxWrapperClassName = void 0;
    if (ownProps.value) {
      checkboxWrapperClassName = 'checked';
    }

    return {
      checkedValue: checkedValue,
      uncheckedValue: uncheckedValue,
      checkboxWrapperClassName: checkboxWrapperClassName
    };
  };

  var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return {
      dispatch: dispatch
    };
  };

  var mergeProps = function mergeProps(stateProps, dispatchProps, ownProps) {
    return _extends({}, stateProps, dispatchProps, ownProps, {
      onChange: function onChange(event) {
        var formId = ownProps.formId;
        var attribute = ownProps.attribute;
        var submodelPath = ownProps.submodelPath;


        dispatchProps.dispatch((0, _updateAction2.default)(formId, attribute, submodelPath, event.target.checked));

        if (ownProps.submitOnChange) {
          event.target.form.submit();
        }
      },
      saveInitialValue: function saveInitialValue() {
        var formId = ownProps.formId;
        var attribute = ownProps.attribute;
        var submodelPath = ownProps.submodelPath;


        dispatchProps.dispatch((0, _updateAction2.default)(formId, attribute, submodelPath, false));
      }
    });
  };

  exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps)(_Checkbox2.default);
});