(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react-redux', '../../actions/updateAction', '../../utils/stateNavigation', '../../components/inputs/Select'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react-redux'), require('../../actions/updateAction'), require('../../utils/stateNavigation'), require('../../components/inputs/Select'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.reactRedux, global.updateAction, global.stateNavigation, global.Select);
    global.Select = mod.exports;
  }
})(this, function (exports, _reactRedux, _updateAction, _stateNavigation, _Select) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _updateAction2 = _interopRequireDefault(_updateAction);

  var _Select2 = _interopRequireDefault(_Select);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var mapStateToProps = function mapStateToProps(state, ownProps) {
    var path = (0, _stateNavigation.navigateThroughSubmodels)(state.rform[ownProps.formId], ownProps.submodelPath || []);
    var value = path && path[ownProps.attribute];

    return { value: value };
  };

  var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return {
      dispatch: dispatch
    };
  };

  var mergeProps = function mergeProps(stateProps, dispatchProps, ownProps) {
    return _extends({}, ownProps, stateProps, dispatchProps, {
      saveInitialValue: function saveInitialValue() {
        var formId = ownProps.formId;
        var attribute = ownProps.attribute;
        var submodelPath = ownProps.submodelPath;
        var value = ownProps.value;
        var options = ownProps.options;

        var initialValue = value || options[0] && options[0].value;

        dispatchProps.dispatch((0, _updateAction2.default)(formId, attribute, submodelPath, initialValue));
      }
    });
  };

  exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps)(_Select2.default);
});