(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', './reducers/index', './containers/Form', './containers/FormButton', './wrappers/InputSet', './wrappers/Input', './wrappers/Button', './wrappers/Label', './wrappers/Errors', './object/FormObject', './object/adapters/FormData', './object/adapters/JsonApi', './actions/updateAction', './actions/setupAction', './actions/registerSubmodelForm', './actions/unregisterSubmodelForm', './utils/modelParams', './utils/stateNavigation'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('./reducers/index'), require('./containers/Form'), require('./containers/FormButton'), require('./wrappers/InputSet'), require('./wrappers/Input'), require('./wrappers/Button'), require('./wrappers/Label'), require('./wrappers/Errors'), require('./object/FormObject'), require('./object/adapters/FormData'), require('./object/adapters/JsonApi'), require('./actions/updateAction'), require('./actions/setupAction'), require('./actions/registerSubmodelForm'), require('./actions/unregisterSubmodelForm'), require('./utils/modelParams'), require('./utils/stateNavigation'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.index, global.Form, global.FormButton, global.InputSet, global.Input, global.Button, global.Label, global.Errors, global.FormObject, global.FormData, global.JsonApi, global.updateAction, global.setupAction, global.registerSubmodelForm, global.unregisterSubmodelForm, global.modelParams, global.stateNavigation);
    global.index = mod.exports;
  }
})(this, function (exports, _index, _Form, _FormButton, _InputSet, _Input, _Button, _Label, _Errors, _FormObject, _FormData, _JsonApi, _updateAction, _setupAction, _registerSubmodelForm, _unregisterSubmodelForm, _modelParams, _stateNavigation) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.navigateThroughSubmodels = exports.getName = exports.getId = exports.unregisterSubmodelForm = exports.registerSubmodelForm = exports.setupAction = exports.updateAction = exports.JsonApiAdapter = exports.FormDataAdapter = exports.FormObject = exports.Errors = exports.Label = exports.Button = exports.InputSet = exports.Input = exports.FormButton = exports.Form = exports.initialState = exports.reducer = undefined;

  var _index2 = _interopRequireDefault(_index);

  var _Form2 = _interopRequireDefault(_Form);

  var _FormButton2 = _interopRequireDefault(_FormButton);

  var _InputSet2 = _interopRequireDefault(_InputSet);

  var _Input2 = _interopRequireDefault(_Input);

  var _Button2 = _interopRequireDefault(_Button);

  var _Label2 = _interopRequireDefault(_Label);

  var _Errors2 = _interopRequireDefault(_Errors);

  var _FormObject2 = _interopRequireDefault(_FormObject);

  var _FormData2 = _interopRequireDefault(_FormData);

  var _JsonApi2 = _interopRequireDefault(_JsonApi);

  var _updateAction2 = _interopRequireDefault(_updateAction);

  var _setupAction2 = _interopRequireDefault(_setupAction);

  var _registerSubmodelForm2 = _interopRequireDefault(_registerSubmodelForm);

  var _unregisterSubmodelForm2 = _interopRequireDefault(_unregisterSubmodelForm);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  exports.reducer = _index2.default;
  exports.initialState = _index.initialState;
  exports.Form = _Form2.default;
  exports.FormButton = _FormButton2.default;
  exports.Input = _Input2.default;
  exports.InputSet = _InputSet2.default;
  exports.Button = _Button2.default;
  exports.Label = _Label2.default;
  exports.Errors = _Errors2.default;
  exports.FormObject = _FormObject2.default;
  exports.FormDataAdapter = _FormData2.default;
  exports.JsonApiAdapter = _JsonApi2.default;
  exports.updateAction = _updateAction2.default;
  exports.setupAction = _setupAction2.default;
  exports.registerSubmodelForm = _registerSubmodelForm2.default;
  exports.unregisterSubmodelForm = _unregisterSubmodelForm2.default;
  exports.getId = _modelParams.getId;
  exports.getName = _modelParams.getName;
  exports.navigateThroughSubmodels = _stateNavigation.navigateThroughSubmodels;
});