(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'lodash/values', 'lodash/flatten', './Validator', '../utils/getErrors'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('lodash/values'), require('lodash/flatten'), require('./Validator'), require('../utils/getErrors'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.values, global.flatten, global.Validator, global.getErrors);
    global.Validation = mod.exports;
  }
})(this, function (exports, _values, _flatten, _Validator, _getErrors) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _values2 = _interopRequireDefault(_values);

  var _flatten2 = _interopRequireDefault(_flatten);

  var _Validator2 = _interopRequireDefault(_Validator);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var NonValidator = function () {
    function NonValidator() {
      _classCallCheck(this, NonValidator);
    }

    _createClass(NonValidator, [{
      key: 'filled',
      value: function filled() {
        return true;
      }
    }]);

    return NonValidator;
  }();

  var Validation = function () {
    function Validation() {
      _classCallCheck(this, Validation);

      this.ALL = 'ALL';
    }

    _createClass(Validation, [{
      key: 'validate',
      value: function validate() {
        var property = arguments.length <= 0 || arguments[0] === undefined ? this.ALL : arguments[0];

        this._resetErrors();
        this.validation();
        return this._validationErrorsIn(property);
      }
    }, {
      key: 'configure',
      value: function configure(configurations) {
        this._configurations = configurations;
      }
    }, {
      key: 'required',
      value: function required(property) {
        var defaultFilledPredicate = arguments.length <= 1 || arguments[1] === undefined ? true : arguments[1];

        return new _Validator2.default(property, this.attributes, this._currentSubmodel, (0, _getErrors.errorKey)(property, [this._currentSubmodel]), // !
        defaultFilledPredicate, this._configurations);
      }
    }, {
      key: 'maybe',
      value: function maybe(property) {
        var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

        if (options.if !== false || options.if === undefined && this.attributes[property]) {
          return this.required(property, false);
        } else {
          return new NonValidator();
        }
      }
    }, {
      key: 'inSubmodel',
      value: function inSubmodel(submodel, callback) {
        this._currentSubmodel = submodel;
        callback.bind(this)();
      }
    }, {
      key: '_resetErrors',
      value: function _resetErrors() {
        this.attributes[this.ERRORCONTAINER] = {};
        this._currentSubmodel = null;
      }
    }, {
      key: '_validationErrorsIn',
      value: function _validationErrorsIn(property) {
        var errors = this.attributes[_getErrors.ERRORCONTAINER];
        if (property == this.ALL) {
          return (0, _flatten2.default)((0, _values2.default)(errors)).length && errors;
        } else {
          return errors[property] && errors[property].length && errors;
        }
      }
    }]);

    return Validation;
  }();

  exports.default = Validation;
});