(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'lodash/forIn', './Base'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('lodash/forIn'), require('./Base'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.forIn, global.Base);
    global.FormData = mod.exports;
  }
})(this, function (exports, _forIn, _Base) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _forIn2 = _interopRequireDefault(_forIn);

  var _Base2 = _interopRequireDefault(_Base);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj;
  };

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var FormDataAdapter = function (_BaseAdapter) {
    _inherits(FormDataAdapter, _BaseAdapter);

    function FormDataAdapter() {
      _classCallCheck(this, FormDataAdapter);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(FormDataAdapter).apply(this, arguments));
    }

    _createClass(FormDataAdapter, [{
      key: 'handleAjaxResponse',
      value: function handleAjaxResponse(json) {
        // TODO: errors potentially not working anymore, needs { formId => errors }
        var meta = json.meta;

        var _ret = function () {
          switch (json.status) {
            case 'success':
              var responseChanges = {};
              (0, _forIn2.default)(json.changes, function (changedInstance, changedList) {
                responseChanges[changedList] = responseChanges[changedList] || {};
                responseChanges[changedList][changedInstance.id] = changedInstance;
              });
              return {
                v: [responseChanges, null, meta]
              };
            case 'formErrors':
              return {
                v: [null, json.errors, meta]
              };
            default:
              throw 'Unknown json.status "' + json.status + '"';
          }
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }
    }, {
      key: '_addModelPropsToFormData',
      value: function _addModelPropsToFormData(formData) {
        var model = this.model;
        var attrs = this.attrs;
        var properties = this.properties;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {

          for (var _iterator = properties[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var property = _step.value;

            this._setFormDataValue(formData, model + '[' + property + ']', attrs[property]);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
    }, {
      key: '_addSubmodelPropsToFormData',
      value: function _addSubmodelPropsToFormData(formData) {
        var model = this.model;
        var submodelConfig = this.submodelConfig;
        var attrs = this.attrs;


        if (submodelConfig) {
          for (var submodel in submodelConfig) {
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
              for (var _iterator2 = submodelConfig[submodel][Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                var property = _step2.value;

                this._setFormDataValue(formData, model + '[' + submodel + '][' + property + ']', attrs[submodel][property]);
              }
            } catch (err) {
              _didIteratorError2 = true;
              _iteratorError2 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }
              } finally {
                if (_didIteratorError2) {
                  throw _iteratorError2;
                }
              }
            }
          }
        }
      }
    }, {
      key: '_setFormDataValue',
      value: function _setFormDataValue(formData, key, value) {
        if (!value) {
          formData.append(key, '');
        } else {
          formData.append(key, value);
        }
      }
    }, {
      key: '_addMetaFieldsToFormData',
      value: function _addMetaFieldsToFormData(formData) {
        var form = this.form;
        var metaFields = ['utf8', 'authenticity_token', 'commit'];

        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = metaFields[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var metaField = _step3.value;

            formData.append(metaField, form[metaField] && form[metaField].value);
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }
      }
    }, {
      key: '_addMethodToFormData',
      value: function _addMethodToFormData(formData) {
        var form = this.form;
        var method = form._method ? form._method.value : 'POST';

        formData.append('_method', method);
      }
    }, {
      key: 'requestHash',
      get: function get() {
        var data = this._formData;

        var options = {
          method: this.form._method.value,
          body: data,
          credentials: 'same-origin',
          headers: {
            Accept: 'application/json'
          }
        };

        if (this.form.authenticity_token) options.headers['X-CSRF-TOKEN'] = this.form.authenticity_token.value;

        return options;
      }
    }, {
      key: '_formData',
      get: function get() {
        var formDataObject = new FormData();
        this._addModelPropsToFormData(formDataObject);
        this._addSubmodelPropsToFormData(formDataObject);
        this._addMetaFieldsToFormData(formDataObject);
        this._addMethodToFormData(formDataObject);
        return formDataObject;
      }
    }]);

    return FormDataAdapter;
  }(_Base2.default);

  exports.default = FormDataAdapter;
});