(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', '../object/FormObject', 'lodash/compact', 'lodash/flatten', 'react'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('../object/FormObject'), require('lodash/compact'), require('lodash/flatten'), require('react'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.FormObject, global.compact, global.flatten, global.react);
    global.defaultFormObject = mod.exports;
  }
})(this, function (exports, _FormObject2, _compact, _flatten, _react) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = defaultFormObject;

  var _FormObject3 = _interopRequireDefault(_FormObject2);

  var _compact2 = _interopRequireDefault(_compact);

  var _flatten2 = _interopRequireDefault(_flatten);

  var _react2 = _interopRequireDefault(_react);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  function defaultFormObject(model, children) {
    var properties = collectPropertiesFromAllChildren(children);

    var formObject = function (_FormObject) {
      _inherits(DefaultFormObject, _FormObject);

      function DefaultFormObject() {
        _classCallCheck(this, DefaultFormObject);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(DefaultFormObject).apply(this, arguments));
      }

      _createClass(DefaultFormObject, null, [{
        key: 'properties',
        get: function get() {
          return properties;
        }
      }, {
        key: 'model',
        get: function get() {
          return model;
        }
      }]);

      return DefaultFormObject;
    }(_FormObject3.default);
    // formObject.__defineGetter__('properties', function() { return ['query'] })
    // formObject.__defineGetter__('model', function() { return 'search' })
    return formObject;
  }

  function collectPropertiesFromAllChildren(children) {
    var properties = [];

    _react2.default.Children.map(children, function (child) {
      if (!child.props) return;
      if (child.props.attribute) properties.push(child.props.attribute);
      if (child.props.children) {
        var recursiveProperties = collectPropertiesFromAllChildren(child.props.children);
        properties.push(recursiveProperties);
      }
    });

    return (0, _compact2.default)((0, _flatten2.default)(properties));
  }
});