(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'lodash/concat', 'lodash/compact'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('lodash/concat'), require('lodash/compact'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.concat, global.compact);
    global.getErrors = mod.exports;
  }
})(this, function (exports, _concat, _compact) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ERRORCONTAINER = undefined;
  exports.default = getErrors;
  exports.errorKey = errorKey;

  var _concat2 = _interopRequireDefault(_concat);

  var _compact2 = _interopRequireDefault(_compact);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function getErrors(formState, attribute) {
    var submodelPath = arguments.length <= 2 || arguments[2] === undefined ? [] : arguments[2];
    var additionalErrors = arguments.length <= 3 || arguments[3] === undefined ? [] : arguments[3];

    // get saved & server provided errors, concat them together
    var stateErrors = [];
    if (formState && formState[ERRORCONTAINER]) {
      stateErrors = formState[ERRORCONTAINER][errorKey(attribute, submodelPath)] || [];
    }
    return (0, _compact2.default)((0, _concat2.default)(stateErrors, additionalErrors));
  }

  function errorKey(property) {
    var submodelPath = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];

    submodelPath = (0, _compact2.default)(submodelPath);
    submodelPath.push(property);
    return submodelPath.join('.');
  }

  var ERRORCONTAINER = exports.ERRORCONTAINER = '_errors';
});