(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.mixin = mod.exports;
  }
})(this, function (exports) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = mixin;
  function mixin(target, source) {
    var targetProto = target.prototype;
    var sourceProto = source.prototype;

    Object.getOwnPropertyNames(sourceProto).forEach(function (name) {
      if (name !== "constructor") {
        Object.defineProperty(targetProto, name, Object.getOwnPropertyDescriptor(sourceProto, name));
      }
    });
  }
});