(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.modelParams = mod.exports;
  }
})(this, function (exports) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.getName = getName;
  exports.getId = getId;
  function getName(model, attribute, multipleSubmodels) {
    var submodelPath = arguments.length <= 3 || arguments[3] === undefined ? [] : arguments[3];

    var name = model;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = submodelPath[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var step = _step.value;

        name += "[" + step + "]";
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    if (multipleSubmodels) {
      return name + "[][" + attribute + "]"; // TODO: Does this even work in rails?
    } else {
      return name + "[" + attribute + "]";
    }
  }

  function getId(formId, model, attribute) {
    var submodelPath = arguments.length <= 3 || arguments[3] === undefined ? [] : arguments[3];

    if (!formId) throw "#getId needs a formId (model: " + model + ", attribute: " + attribute + ")";
    if (!model) throw "#getId needs a model (formId: " + formId + ", attribute: " + attribute + ")";

    var id = formId + "_" + model + "_";
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = submodelPath[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var step = _step2.value;

        id += step + "_";
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    return id + "_" + attribute;
  }
});