(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'lodash/isNil'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('lodash/isNil'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.isNil);
    global.stateNavigation = mod.exports;
  }
})(this, function (exports, _isNil) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.navigateThroughSubmodels = navigateThroughSubmodels;

  var _isNil2 = _interopRequireDefault(_isNil);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function navigateThroughSubmodels(basePath) {
    var submodelPath = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
    var fillEmpty = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];
    var lastFill = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];

    if (basePath && submodelPath.length) {
      for (var i = 0; i < submodelPath.length; i++) {
        var step = submodelPath[i];
        var isLastStep = i == submodelPath.length - 1;

        if (!basePath[step] && fillEmpty) basePath[step] = isLastStep ? lastFill : {};
        basePath = basePath[step];
      }
    }

    return basePath;
  }
});