(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'lodash/compact'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('lodash/compact'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.compact);
    global.translations = mod.exports;
  }
})(this, function (exports, _compact) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.optionalTranslation = optionalTranslation;

  var _compact2 = _interopRequireDefault(_compact);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj;
  };

  // TODO: integer steps might interfere (submodel keys)
  function optionalTranslation() {
    if (!global.I18n) return;

    // Extract options from last argument
    var options = {};

    for (var _len = arguments.length, pathSteps = Array(_len), _key = 0; _key < _len; _key++) {
      pathSteps[_key] = arguments[_key];
    }

    if (_typeof(pathSteps[pathSteps.length - 1]) === 'object') {
      options = pathSteps.pop();
    }

    var path = (0, _compact2.default)(pathSteps).join('.');
    return global.I18n.t(path, options);
  }
});