(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'lodash/assign', 'lodash/values', 'lodash/forIn'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('lodash/assign'), require('lodash/values'), require('lodash/forIn'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.assign, global.values, global.forIn);
    global.validate = mod.exports;
  }
})(this, function (exports, _assign, _values, _forIn) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.validateForm = undefined;

  var _assign2 = _interopRequireDefault(_assign);

  var _values2 = _interopRequireDefault(_values);

  var _forIn2 = _interopRequireDefault(_forIn);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _toConsumableArray(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
        arr2[i] = arr[i];
      }

      return arr2;
    } else {
      return Array.from(arr);
    }
  }

  function validateForm(baseFormObject) {
    var returnHash = { valid: true, errors: {} };
    (0, _forIn2.default)(_relevantFormObjects(baseFormObject), function (formObject, formId) {
      var errors = formObject.validate();
      if (errors) {
        returnHash.valid = false;
        returnHash.errors[formId] = errors;
      }
    });
    return returnHash;
  }

  function _relevantFormObjects(baseFormObject) {
    var objects = {};
    objects[baseFormObject.formId] = baseFormObject;

    var subFormObjects = baseFormObject.submodelFormObjects;
    while ((0, _values2.default)(subFormObjects).length) {
      (0, _assign2.default)(objects, subFormObjects);
      subFormObjects = _assign2.default.apply(undefined, _toConsumableArray((0, _values2.default)(subFormObjects).map(function (fo) {
        return fo.submodelFormObjects;
      })));
    }

    return objects;
  }

  exports.validateForm = validateForm;
});